unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls;


type

  TMainForm = class(TForm)
    PageControl1: TPageControl;
    LCD: TTabSheet;
    GroupBox1: TGroupBox;
    VFD: TTabSheet;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    home_str_: TSpeedButton;
    end_str_: TSpeedButton;
    home_all_: TSpeedButton;
    end_all_: TSpeedButton;
    moveXY_: TSpeedButton;
    cursor_en_: TSpeedButton;
    cursor_dis_: TSpeedButton;
    GroupBox2: TGroupBox;
    owerwrite_: TSpeedButton;
    horizontal_: TSpeedButton;
    vertical_: TSpeedButton;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    char_val: TEdit;
    Label5: TLabel;
    hex_val: TEdit;
    send_char_: TSpeedButton;
    send_hex_: TSpeedButton;
    clear_disp_: TSpeedButton;
    GroupBox4: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    home_str_VFD: TSpeedButton;
    end_str_VFD: TSpeedButton;
    home_all_VFD: TSpeedButton;
    end_all_VFD: TSpeedButton;
    moveXY_VFD: TSpeedButton;
    cursor_en_VFD: TSpeedButton;
    cursor_dis_VFD: TSpeedButton;
    Edit6: TEdit;
    Edit7: TEdit;
    GroupBox5: TGroupBox;
    owerwrite_VFD: TSpeedButton;
    horizontal_VFD: TSpeedButton;
    vertical_VFD: TSpeedButton;
    GroupBox6: TGroupBox;
    Label1: TLabel;
    Label8: TLabel;
    send_char_VFD: TSpeedButton;
    send_hex_VFD: TSpeedButton;
    clear_disp_VFD: TSpeedButton;
    char_val_VFD: TEdit;
    hex_val_VFD: TEdit;
    GroupBox7: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    GroupBox8: TGroupBox;
    GroupBox9: TGroupBox;
    Label11: TLabel;
    Label13: TLabel;
    font_val_: TEdit;
    Label14: TLabel;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit16: TEdit;
    load_sym_: TSpeedButton;
    get_sym_: TSpeedButton;
    en_sym_: TSpeedButton;
    dis_sym_: TSpeedButton;
    Edit17: TEdit;
    en_EEPROM: TCheckBox;
    font_set_: TSpeedButton;
    SpeedButton1: TSpeedButton;
    en_user_char_: TCheckBox;
    send_str_: TButton;
    str: TEdit;
    Label12: TLabel;
    ComboBox3: TComboBox;
    Label15: TLabel;
    procedure home_str_Click(Sender: TObject);
    procedure SpeedButton3Cl(Sender: TObject);
    procedure home_all_Click(Sender: TObject);
    procedure end_all_Click(Sender: TObject);
    procedure cursor_en_Click(Sender: TObject);
    procedure cursor_dis_Click(Sender: TObject);
    procedure moveXY_Click(Sender: TObject);
    procedure owerwrite_Click(Sender: TObject);
    procedure horizontal_Click(Sender: TObject);
    procedure vertical_Click(Sender: TObject);
    procedure send_hex_Click(Sender: TObject);
    procedure clear_disp_Click(Sender: TObject);
    procedure send_char_Click(Sender: TObject);
    procedure moveXY_VFDClick(Sender: TObject);
    procedure send_hex_VFDClick(Sender: TObject);
    procedure get_sym_Click(Sender: TObject);
    procedure load_sym_Click(Sender: TObject);
    procedure dis_user_charClick(Sender: TObject);
    procedure en_sym_Click(Sender: TObject);
    procedure dis_sym_Click(Sender: TObject);
    procedure send_char_VFDClick(Sender: TObject);
    procedure font_set_Click(Sender: TObject);
    procedure ShowError(res: integer);
    procedure send_str_Click(Sender: TObject);
  public
    Activated: Boolean;
  end;

var
  MainForm: TMainForm;
  DLLInstance : THandle;

implementation

uses
  Math, lpos_vfd_lcd;

{$R *.dfm}

//     
procedure TMainForm.home_str_Click(Sender: TObject);
Var
	res : Integer;
begin
  res:=home_str();
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//     
procedure TMainForm.SpeedButton3Cl(Sender: TObject);
Var
	res : Integer;
begin
  res:=end_str();
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//     
procedure TMainForm.home_all_Click(Sender: TObject);
Var
	res : Integer;
begin
  res:=home_all();
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//     
procedure TMainForm.end_all_Click(Sender: TObject);
Var
	res : Integer;
begin
  res:=end_all();
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

// 
procedure TMainForm.cursor_en_Click(Sender: TObject);
Var
	res : Integer;
begin
  res:=cursor_en();
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

// 
procedure TMainForm.cursor_dis_Click(Sender: TObject);
Var
	res : Integer;
begin
  res:=cursor_dis();
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

// 
procedure TMainForm.moveXY_Click(Sender: TObject);
Var
	res : Integer;
begin
  res:=moveXY(strtoint(Edit2.Text),strtoint(Edit3.Text));
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//     
procedure TMainForm.owerwrite_Click(Sender: TObject);
Var
	res : Integer;
begin
  res:=owerwrite();
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//      
procedure TMainForm.horizontal_Click(Sender: TObject);
Var
	res : Integer;
begin
  res:=horizontal();
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//      
procedure TMainForm.vertical_Click(Sender: TObject);
Var
	res : Integer;
begin
  res:=vertical();
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//     
procedure TMainForm.send_hex_Click(Sender: TObject);
Var
	res : Integer;
begin
  res:=send_hex(StrToIntDef('$' + hex_val.Text, 0));
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//  
procedure TMainForm.clear_disp_Click(Sender: TObject);
Var
	res : Integer;
begin
  res:=clear_disp();
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//    
procedure TMainForm.send_char_Click(Sender: TObject);
Var
	res : Integer;
begin
  res:=send_char(ord(char_val.Text[1]));
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

// 
procedure TMainForm.moveXY_VFDClick(Sender: TObject);
Var
	res : Integer;
begin
  res:=moveXY(strtoint(Edit6.Text),strtoint(Edit7.Text));
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//     
procedure TMainForm.send_hex_VFDClick(Sender: TObject);
Var
	res : Integer;
begin
  res:=send_hex(StrToIntDef('$' + hex_val_VFD.Text, 0));
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//    
procedure TMainForm.get_sym_Click(Sender: TObject);
Var
 bit_arr: Array[1..7] of byte;
 font_val: byte;
 res: integer;
begin
  font_val:=StrToIntDef('$' + font_val_.Text, 0);
  res:=get_sym(@bit_arr, font_val);
  If res <> ERROR_NO_ERROR then ShowError(res);
  Edit11.Text:=IntToHex(bit_arr[1], 0);
  Edit12.Text:=IntToHex(bit_arr[2], 0);
  Edit13.Text:=IntToHex(bit_arr[3], 0);
  Edit14.Text:=IntToHex(bit_arr[4], 0);
  Edit15.Text:=IntToHex(bit_arr[5], 0);
  Edit16.Text:=IntToHex(bit_arr[6], 0);
  Edit17.Text:=IntToHex(bit_arr[7], 0);
end;

//     (User chars)
procedure TMainForm.load_sym_Click(Sender: TObject);
Var
 bit_arr: Array[1..7] of byte;
 font_val: byte;
 res: integer;
begin
  font_val:=StrToIntDef('$' + font_val_.Text, 0);
  bit_arr[1]:=StrToIntDef('$' + Edit11.Text, 0);
  bit_arr[2]:=StrToIntDef('$' + Edit12.Text, 0);
  bit_arr[3]:=StrToIntDef('$' + Edit13.Text, 0);
  bit_arr[4]:=StrToIntDef('$' + Edit14.Text, 0);
  bit_arr[5]:=StrToIntDef('$' + Edit15.Text, 0);
  bit_arr[6]:=StrToIntDef('$' + Edit16.Text, 0);
  bit_arr[7]:=StrToIntDef('$' + Edit17.Text, 0);
  res:=load_sym(@bit_arr,font_val);
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//      
//user chars
procedure TMainForm.dis_user_charClick(Sender: TObject);
Var
  res: integer;
begin
  if en_user_char_.Checked
    then res:=en_user_char()
    else res:=dis_user_char();
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//     
//user chars
procedure TMainForm.en_sym_Click(Sender: TObject);
Var
 font_val: byte;
 res: integer;
begin
  font_val:=StrToIntDef('$' + font_val_.Text, 0);
  res:=en_sym(font_val);
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//     
//user chars
procedure TMainForm.dis_sym_Click(Sender: TObject);
Var
 font_val: byte;
 res: integer;
begin
  font_val:=StrToIntDef('$' + font_val_.Text, 0);
  res:=dis_sym(font_val);
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//    
procedure TMainForm.send_char_VFDClick(Sender: TObject);
Var
  res: integer;
begin
  res:=send_char(ord(char_val_VFD.Text[1]));
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//   
procedure TMainForm.font_set_Click(Sender: TObject);
var
  lo, hi,EEPROM_en: byte;
  res: integer;
begin
  lo:=ComboBox1.ItemIndex;
  hi:=ComboBox2.ItemIndex;
  EEPROM_en:=0;
  if en_EEPROM.Checked
    then EEPROM_en:=1;
  res:=font_set(lo, hi, EEPROM_en);
  If res <> ERROR_NO_ERROR then ShowError(res);
end;

//      
procedure TMainForm.ShowError(res: integer);
begin
  Case res of
		//ERROR_NO_ERROR				: ShowMessage('  ');
		ERROR_FAILED				: ShowMessage('   !');
    Else ShowMessage('  '+IntToStr(res));
  End;
end;


procedure TMainForm.send_str_Click(Sender: TObject);
Var
buf: array [0..255] of byte;
i: byte;
res: integer;
begin
  for i:=0 to length(str.Text)-1 do
    buf[i]:=ord(str.Text[i+1]);

  if ComboBox3.ItemIndex=0
    then res:=send_str(@buf, 0, length(str.Text))
    else res:=send_str(@buf, 1, length(str.Text));
    
  If res <> ERROR_NO_ERROR then ShowError(res);

end;

end.
